package com.kdanmobile.admanager

import android.app.Activity
import android.content.Context
import android.view.View

interface AdManager {
    fun init(context: Context, adUnitId: String = "", volume: Float)
    var isInitialized: Boolean
    val onInitListeners: List<Runnable>

    fun requestInterstitial(activity: Activity, adUnitId: String)
    fun showInterstitial(adUnitId: String): Boolean
    fun destroyInterstitial(activity: Activity)
    fun registerInterstitialAdListener(interstitialAdListener: InterstitialAdListener)
    fun unregisterInterstitialAdListener(interstitialAdListener: InterstitialAdListener)
    fun isInterstitialLoading(adUnitId: String): Boolean
    fun isInterstitialLoaded(adUnitId: String): Boolean

    fun registerNativeAdListener(nativeAdNetworkListener: NativeAdNetworkListener)
    fun unregisterNativeAdListener(nativeAdNetworkListener: NativeAdNetworkListener)
    fun requestNative(adUnitId: String, nativeAdViewBinder: NativeAdViewBinder)
    fun takeNativeAdView(adUnitId: String, nativeAdViewBinder: NativeAdViewBinder): View?
}